package com.fjhx.sale.service.commission.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.ObjectUtil;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.fjhx.sale.entity.commission.po.CommissionType;
import com.fjhx.sale.entity.commission.vo.CommissionTypeVo;
import com.fjhx.sale.mapper.commission.CommissionTypeMapper;
import com.fjhx.sale.service.commission.CommissionTypeService;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.stream.Collectors;

/**
 * <p>
 * 业绩提成类型 服务实现类
 * </p>
 *
 * @author
 * @since 2023-09-20
 */
@Service
public class CommissionTypeServiceImpl extends ServiceImpl<CommissionTypeMapper, CommissionType> implements CommissionTypeService {

    @Override
    public List<CommissionTypeVo> getList() {
        List<CommissionType> list = this.list();
        List<CommissionTypeVo> commissionTypeVos = BeanUtil.copyToList(list, CommissionTypeVo.class);
        return commissionTypeVos;
    }

    @Override
    public void addOrEdit(List<CommissionType> commissionTypeList) {
        List<Long> ids = commissionTypeList.stream().map(CommissionType::getId)
                .distinct().filter(item -> ObjectUtil.isNotEmpty(item)).collect(Collectors.toList());
        this.remove(q -> q.notIn(ObjectUtil.isNotEmpty(ids), CommissionType::getId, ids));
        this.saveOrUpdateBatch(commissionTypeList);
    }

    @Override
    public void delete(Long id) {
        this.removeById(id);
    }

}
